function [x, y] = sim_master_blk_I(Seed)
%% block-equi factor copula with Q = 3, |G_q| = 15, q = 1,2,3.
disp(strcat('Round:',Seed))
ver
Seed = str2num(Seed);
seed = 1234*Seed;

q            = [5 10 90 95]/100;%[15 85]/100;%  
theta0       = [.25 -.5    1/2 1 1.5 2];
LB           = [.01 -.99   0.*ones(4,1)'];
UB           = [.49  .99   5.*ones(4,1)'];
    
S  = 25;
N  = 15;
T  = 500;
B  = 500*T;    
exog =  1;
ar       = .65; 
var_type = 1;
rhoS =  1;
test =  1;
rng_type = 'threefry4x64_20';% any 'threefry4x64_20';%'twister';%'mlfg6331_64';% 
ini = 'true'; %if true (false), then (no) grid search is used in addition to surrogate to obtain initials             
Zblock ='threeZ';% nan;%
eps_dist = 'norm';% 'st'
rng(0,rng_type)

%%
Weight     = 1;
blks = [ones(N/3,1)' repmat(2, N/3,1)' repmat(3, N/3,1)']';

other_null = [T N];
other_est  = [T S N];
phi        = [0.01, 0.05, 0.05, 0.10, 0.85];
phi1       = [0.1, 0.65, 0.1, 0.10, 0.5]; 
% some container
data_resid=NaN(T,N); % AR-GARCH residuals
data_param=NaN(N,length(phi)); % AR-GARCH parameters
data_uresid_semipar=NaN(T,N); % ARMA-GARCH PIT residuals (semiparametric)
%%
if exog== 0
    Z = [nan(T,3)]; Z_hat = [nan(T,3)];
else
     
    Z_1 = randn(RandStream.create(rng_type,'NumStreams',N+2+2*strcmp(Zblock, 'threeZ'),'StreamIndices',1,'Seed',seed),T,1);%(-1+2.*rand(RandStream.create(rng_type,'NumStreams',N+4,'StreamIndices',1,'Seed',seed),T,1)).*sqrt(3);%randn(RandStream.create(rng_type,'NumStreams',N+4,'StreamIndices',1,'Seed',seed),T,1);%.^2-1;%2*randn(RandStream.create(rng_type,'NumStreams',N+4,'StreamIndices',1,'Seed',seed),T,1);
    W = zeros(T,1); W(1) = Z_1(1);
    for tt = 2:T
        W(tt) = ar*W(tt-1)+ Z_1(tt);
    end
    mdl    = arima(1,0,0);
    mdl_hat = estimate(mdl,W,'Display','off');
    if ar == 0
        Z_hat_1 = Z_1;
    else
        Z_hat_1  = infer(mdl_hat,W);
    end
    clear W
    if strcmp(Zblock, 'oneZ')
        Z = [Z_1 nan(T,2)]; Z_hat = [Z_hat_1 nan(T,2)];
    elseif strcmp(Zblock, 'threeZ')
        Z0_2 = randn(RandStream.create(rng_type,'NumStreams',N+4,'StreamIndices',2,'Seed',seed),T,1);
        W = tarch_simulate(Z0_2,phi1(3:5)',1,0,1,'NORMAL',2); % P=1,O=0,Q=1 leads to GARCH model
        [~,~,ht,~,~,~,~] = tarch(W,1,0,1,'NORMAL',2,phi1(3:5)',optimset('display','off'));
        Z_hat_2 = log((abs(W)./sqrt(ht))); Z_2 = log((abs(Z0_2)));
        
        Z_3 = randn(RandStream.create(rng_type,'NumStreams',N+4,'StreamIndices',3,'Seed',seed),T,1);
        Z = [Z_hat_1 Z_hat_2 Z_3]; Z_hat = [Z_1 Z_2 Z_3];%;
    end

end
%%

[data, ~] = return_dgp_blk(theta0,other_null,phi,Z,Zblock,eps_dist,seed,rng_type,blks);     
   
for nn=1:N
                [~,temp_param,~,~,temp_resid,~]=fitARMAGARCH(data(:,nn),[1,0,1,0,1],'NORMAL',phi);
                data_resid(:,nn)=temp_resid;
                data_param(nn,:)=temp_param;
                data_uresid_semipar(:,nn)=tiedrank(temp_resid)/(T+1);
end 
clear temp_resid temp_param

fun1 = @(x) objfunc_SMM_blk(x, other_est,  data_uresid_semipar, Weight, q, Z_hat, Zblock,eps_dist,seed, blks, rng_type,rhoS);
fun0 = @(x) initials(x,data_uresid_semipar,Weight,q,Z_hat,Zblock,eps_dist,blks,LB,UB,T,N,10,rhoS,rng_type,ini,seed);
opts = optimoptions('surrogateopt','UseParallel',false,'PlotFcn',[],'display','off'); 

[theta_ini0,~,~,~] = surrogateopt(fun1,LB,UB, opts);                        % obtain raw initial value using surrogateopt() w/o need for starting values
theta_ini = fun0(theta_ini0);                                               % obtain refined initial value using grid search over dof-parameter nu (see initials() function)
% theta_ini = theta_ini0;
% 
%
%  opts1 =  optimset('display','off');llb = []; uub = []; [theta_hat,~,~,~] = patternsearch(fun1, theta_ini,[],[],llb,uub,LB,UB,[],opts1);
% theta_ini = theta0;
[theta_hat,~,~,~] = fminsearchbnd(fun1, theta_ini,LB,UB);% obtain estimate

x = [theta_hat theta_ini];
%%

if(test == 1)   
[~,Xsim]  = estimation_sim_blk(theta_hat,other_est,Z_hat,Zblock,eps_dist,seed,rng_type,blks);
Sigma_hat = var_est_blk(data_resid,Xsim,q,B,seed,blks,exog,var_type,rhoS);  
clear Xsim
[J_hat05,~] = num_deriv_blk(theta_hat,data_uresid_semipar,other_est,Weight,blks,q, Z_hat,Zblock,eps_dist,seed,0.1,LB,UB,rng_type,rhoS);
[J_hat01,~] = num_deriv_blk(theta_hat,data_uresid_semipar,other_est,Weight,blks,q, Z_hat,Zblock,eps_dist,seed,0.05,LB,UB,rng_type,rhoS);
Omega_hat_05   = (J_hat05'*Weight*J_hat05)\(J_hat05'*Weight*Sigma_hat*Weight*J_hat05)/(J_hat05'*Weight*J_hat05);
Omega_hat_01   = (J_hat01'*Weight*J_hat01)\(J_hat01'*Weight*Sigma_hat*Weight*J_hat01)/(J_hat01'*Weight*J_hat01);
[~,ghat] = objfunc_SMM_blk(theta_hat,other_est,data_uresid_semipar,Weight,q,Z_hat,Zblock,eps_dist,seed,blks,rng_type,rhoS);
[J05, ~,~,~] = JTest(ghat,T,1000,Weight,Sigma_hat,J_hat05,seed);
[J01, ~,~,~] = JTest(ghat,T,1000,Weight,Sigma_hat,J_hat01,seed);

clear ghat  J_hat05 J_hat01 Sigma_hat

test05 = sqrt(T)*(theta_hat-theta0)./sqrt(diag(Omega_hat_05))';
test01 = sqrt(T)*(theta_hat-theta0)./sqrt(diag(Omega_hat_01))';

 
y = abs([test05 test01]) > 1.96;

y = [y J05 J01];            
else
    y = NaN;
end

save(fullfile(fullfile(pwd, 'results/theta1'),sprintf('theta%d.mat',Seed)),'x');
save(fullfile(fullfile(pwd, 'results/tests1'),sprintf('test%d.mat',Seed)),'y');
clearvars -except x y
end



 


